
#include <sys/sem.h>
#include <sys/shm.h>
#include "msock.h"

#define STICKY_ON_IP 		1
#define STICKY_ON_IP_PORT 	2
#define NON_STICKY		3


/*
** i need to remove this junk from chandra's code of xml parsing
*/
int 
   len_cr=2,
   len_lf=2,
   len_sp=1,
   len_la=1,
   len_ra=1,
   len_fs=1,
   len_ex=1,
   max_char_len=1;

char
   *c_cr="\r",
   *c_lf="\n",
   *c_sp=" ",
   *c_la="<",
   *c_ra=">",
   *c_fs="/",
   *c_ex="!";


struct ip_vs_cb_rule_field rule_fields[] =
{
{"purchase:1.totalAmount:1.", "" },
{"purchase:1.subTotal:1.", "" },
{"purchase:1.subTotal:2.", "" },
{"purchase:1.unitPrice:2.", "" }
};

static struct server server_list[] =
{
  {"fp1.uccs.edu",         0x80c60192},  /*128.198.1.146*/
  {"fp2.uccs.edu",         0x80c60193},  /*128.198.1.147*/
  {"web.uccs.edu",         0x80c60195},  /*128.198.1.149*/
  {"eca.uccs.edu",         0x80c6c0bc},  /*128.198.192.198*/
  {"frodo.uccs.edu",       0x80c6c0b7},  /*128.198.192.183*/
  {"wallace.uccs.edu",     0x80c6c0d0},  /*128.198.192.183*/
  {"default",              0x00000000},
  {"reject",               0xffffffff}

};


int num_rule_fields = sizeof(rule_fields) / sizeof(struct ip_vs_cb_rule_field);

int num_servers = sizeof(server_list) / sizeof(struct server);

int portno;


#define STICKY_SIZE 	200	    /* allocation for maximum # of the sticky connection */

int *sticky_num;          	    /* # of sticky entries in shared mem */
ip_sticky *sticky;


char *getRealServerName(u_long saddr)
{
 int i=0;

 for(i=0; i<num_servers; i++)
 {
  if(server_list[i].addr == saddr)
     return server_list[i].name ;
 }

 return NULL;  /* should not happen but for saftey */
}

/*
** temporary function for checking if the shared memory stuff is working properly or not
** should be removed soon gkgodava@archie.uccs.edu
*/
void printDetails(int semID,ip_sticky *s,int *sticky_num)
{
  int i=0;

  for(i=0;i<(*sticky_num);i++)
   (void) fprintf(stderr,"\a\a\t==>invoked pid %d source address %x destination address is %x\n",getpid(),s[i].source_ip, s[i].dest_ip);
  
  return ;
}

/*
** generates a random number to remove the information from shared memory 
** should be invoked in case of an overflow
*/
int removeSticky(void)
{
 srand(time(NULL));
 return (rand()%STICKY_SIZE);
}

/*
** adds a sticky connection information into the shared memory
*/
void addSticky(u_long saddr,u_long daddr)
{
 int loc;

   critical_lock_on();
 loc = (*sticky_num);
 if((*sticky_num) >= STICKY_SIZE)
   {
   loc = removeSticky();
/*
   printf("\t\t==>call to removeSticky noticed removing %d\n",loc);
*/
   }
 else
    (*sticky_num)++;

    sticky[loc].source_ip = saddr;
    sticky[loc].dest_ip = daddr;
   critical_lock_off();
return;
}

/*
** checks for the connection information i.e sticky or not, in the shared memory
** if found returns destination address else 0 
*/
u_long findSticky(u_long saddr)
{
  int i=0;
  u_long addr=0;

  critical_lock_on();
  for(i=0;i<(*sticky_num);i++) {
   if(saddr == sticky[i].source_ip) {
    critical_lock_off();
    return sticky[i].dest_ip;
   }

  }
   critical_lock_off();
  return 0 ;
}


void clear_rule_fld_values()
{
 int i = 0;
 for(i=0; i < num_rule_fields;i++)
   rule_fields[i].value[0] = '\0';

 return;
}

u_long route_to(char *server_name, int sticky_flag, u_long saddr, int port = 80)
{
 int i=0;
 u_long dest_addr = 0;

 for(i=0; i<num_servers; i++)
 {
  if(strcmp(server_name, server_list[i].name) == 0)
  {
    if(sticky_flag == STICKY_ON_IP)
    {
     addSticky(saddr,server_list[i].addr);
    }
    dest_addr = server_list[i].addr;
    break;
  }
 }
 
 portno = port;

 return dest_addr;
}

/* END OF r1.txt */

u_long rule_configure(char *url, u_long saddr,u_long daddr, u_short sport, u_short dport, u_short protocol)
{
/* White List: List of trusted computers */
if (saddr == 0x80c60192){
  return route_to("web.uccs.edu",STICKY_ON_IP,saddr);
}else if (saddr == 0x80c60192){
  return route_to("web.uccs.edu",STICKY_ON_IP,saddr);
}else if (saddr == 0x80c60193){
  return route_to("web.uccs.edu",STICKY_ON_IP,saddr);
}else if (saddr == 0x80c60194){
  return route_to("web.uccs.edu",STICKY_ON_IP,saddr);
}else if (saddr == 0x80c60195){
  return route_to("web.uccs.edu",STICKY_ON_IP,saddr);
}else if (saddr == 0x80c6012d){
  return route_to("web.uccs.edu",STICKY_ON_IP,saddr);

/* Black List: test */
}else if (saddr == 0x80c60130){
  return route_to("reject",STICKY_ON_IP,saddr);
}if (strstr(url,"/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"aale/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"abailey/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"accounting/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"acoughli/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"aczaplew/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"admrec/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"adventurejoe/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"aepple/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"affirm/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"agagnon/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"agingcenter/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"agreer/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"agroenen/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ahamand/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ahanisch/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ahardy/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"aherrera/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ahickey/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"akhan2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"akraetze/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"alumni/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"amartin7/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"amidboe/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"amilliga/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"amilton/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"angwebboo/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"antebellum/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"anthropo/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"aobrien/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"apacheco/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"aramirez/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"armyrotc/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"aroot/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"artcamp/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"aschoffs/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"asmith2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"aspnet_client/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"athletic/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"auclaire/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"awillia3/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bakerne/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bayen/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bber/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bcook/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"BEFacHdbk/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"benight/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bethel/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bethelstudenthandbook/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bgaddis/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bgala/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bhensley/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bhepperl/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bhiser/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"biology/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bkrobert/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"blade/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bleon/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"blomquist/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bloux/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bmaillou/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bmetzger/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bnoffsin/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bnystuen/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bparker/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bpriefer/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"briandoan/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bschiff/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bsturgeo/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bsuther3/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bursar/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"business/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"bwright/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"campacbd/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cams/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cap/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"careers/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"caregivers/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"casppr/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"catalog.wci/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cbenight/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ccdd/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cchen/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ccps/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ccseminar/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cdecker/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cee/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cellex/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"centeronaging/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cfrazier/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"chancellor/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"chancellorupdate/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"chaucer/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cheerleading/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"chemistry/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"chemres/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cherylteacher/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"citti/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cjimenez/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cjohnso0/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"clas/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"clc/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cmabutler/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cmalfeld/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cmartin3/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cmaynard/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cmundy/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cnoffsin/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"comm/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"commencement/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"commlab/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"commsurvey/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"compsvcs/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"computing/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"conferences/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"conferenceserv/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ConnectioNET_Bank/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"construction/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"conted/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"conted4/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"counsel/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"couplesurvey/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cpederse/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cpendleton/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cragmor/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cragwood/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cschaffn/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cschodor/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"CSGI/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cstephen/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cuop/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cutrauma/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cwetheri/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cwiggins/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"cyberclass/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dalberic/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dance/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"danderso/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"daph2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"daphne/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dbray/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dbristol/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dcarpenter/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ddavison/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ddeboar/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ddesbois/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ddubois/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ddudley/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ddunn/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dfrazier/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dgreenwo/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"discuss/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ditmyer/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dkelsch/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dkieu/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dmclain/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dowens/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dponder/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dprescot/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dsegal/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dsheldon/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dsimons/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dsmith/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dss/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dstradtman/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dtech/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dthorpe/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dweiss/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"dwtinkle/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ealba/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"economics/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ecrumley/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"edc561/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"education/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"efaciana/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"egreene/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"elpomar/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"elund/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"emartine/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"emerplan/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"engl353/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"english/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"english338/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"english339/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"eolson/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"eoreilly/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ergonomics/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"esbarbar/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"esbarbaro/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"etapolch/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ethnicstudies/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ewillia2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ewinterb/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"extendedstudies/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"facassembly/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"facforum/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"facforum1/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"facforum2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"facforum3/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"facforum4/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"facplng/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"fallfest/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"fbleeker/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"fcoolidg/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"fdc/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"firewalker/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"fjodeh/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"food/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"formstest/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"freshsem/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"gardner/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"geoclub/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"geodatalab/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"geogenvs/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ggarcia/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"gilstrap/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"goneill/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"goodrick/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"gradpage/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"gradschl/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"grandma/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"griffin/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"gsmith2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"gstringe/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"gwiley/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"happyday/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"hbeach/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"hdavis/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"healthcenter/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"helpdesk/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"histdiscussion/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"history/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"hkn/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"hmena/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"hmizuno/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"hmoon/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"hnapierk/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"hockey/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"housing/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"hscounselor/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"hwilliam/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"images/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"imolton/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"info/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"installs/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ir/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"irueda/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"isc/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ISIF/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"iss/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"it_old/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jalthona/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jbarnes2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jbarnes3/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jbroker/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jburkhar/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jcannata/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jchamber/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jchilson/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jcoakley/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jconroy/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jcorcoran/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jcrouch/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jdaly/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jderksen/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jennifer/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jfish/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jfitzpat/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jfitzpatrick/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jganger/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jgant/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jgolden/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jgregory/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jhanson/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jharner/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jhensley/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jjesmer/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jjoseph/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jjutten/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jkluge/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jkoa/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jlebaron/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jlongwel/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jlubecki/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jmaahs/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jmartin/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jmartin5/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jmartinez/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jmcconne/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jmillima/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jmocabee/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jpoucel/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jrallo/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jricejon/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jrothe/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jspiche2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"juakali/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jules/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jvangeld/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jwagoner/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jwalsh/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jwarye/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jwilson2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jwintche/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"jzimmer/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"kahearne/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"kbalsick/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"kbisset/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"kcarew/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"kcasey/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"kessick/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"kfeinber/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"kgeddes/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"kgriffith/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"khan/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"kklebe/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"kkposey/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"klagana/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"kleight2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"kmoss/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"kphillip/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"langcult/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"langtech/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lapplega/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lasdean/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lases/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lbecker/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lbecker2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lbrian/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lcaspers/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lcastro/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lcicchin/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"leoandjaime/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lfujimoto/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lgaydos/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lginsberg/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lgrothe/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lhiggins/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lholman/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lhudson/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"library/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ljacobs/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ljohnso2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lkaastra/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lkaplan/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"llawton/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lmcfarland/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lnajjar/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lnierode/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"loki/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lostenbe/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lpage/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lpfeffer/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lphillip/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lpinnock/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lpoe/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lroussea/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lscarbor/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lscott/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lsimm/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lsimpson/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ltc/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lthede/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lullman/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"lwalker/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mae5460/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mainhall/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mandukur/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"marietta/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"masterplan/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mathnerd/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mbelding/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mbl/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mbs/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mbsprogram/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mc2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mdiamond/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mdiehl/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mdugan/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mediaweb/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mfrench3/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mgarcia3/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mgebhard/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mgebhardt/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mhackman/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mhagedor/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"misa/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mjarosz/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mkisley/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mkluge/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mkristiseter/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mlc/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mlondon/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mmassari/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mmillard/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mmiller6/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mmills/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mmiracle/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mmistry/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mobrienr/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mquick/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mramey/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mrowber2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mschoffs/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mschuchm/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"msgt/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mturner/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mvidales/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mwatson2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"mwhedon/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"myoung/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"myweb/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ncampbell/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"nelliott/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ngraber/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"nguzman/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"nissc/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"njlang/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"nlindenm/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"nnugent/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"nreyes/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"nsakaria/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"nsanford/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"nwager/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"nweather/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"nwelch/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"oama/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"online/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"openings/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"oreilly/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"orientation/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"osp/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"oterokolt/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"pastras/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"pbarr/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"pcase/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"pcegiels/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"Pen/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"pgrow/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"pharvey/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"phibetachi/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"philosophy/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"physics111/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"plind/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"pmiller/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"polisci/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"precoll/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"premed/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"projexcel/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"prostudent/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"psychology/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"pub/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"pwall/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"pwaterin/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"qtss/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rbarker/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rdiscenz/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rduray/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rdurham/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"recsports/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rem501/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rfraser/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rgallego/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rgarvie/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rgilbert/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rgill/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rha/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rhine/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rjackson/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rjackson-A/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rjohnso3/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rjohnson/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rkuehn/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rlaroche/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rlorch/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rlucas/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rmaddipa/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rmason/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rmayer/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rmead/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rmeadows/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rnewlon/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rothe/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rpeterso/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rpitts/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rpyati/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rramponi/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rrhine/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rrose/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rsale/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rstroud/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rsundhei/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rswanso2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rtirado/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rtrahern/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rvandermost/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rweigand/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rwidman/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rwidner/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"rwidner.2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sau/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sbdc/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sbourn/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sbrown/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sca/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"scanderson/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"scarroll/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"scarter2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"scheung2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"scioly/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sdebelli/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sdirks/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"segway/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sestwick/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sfischer/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sflahert/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sfrank/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sga/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"shall/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"shall2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sharder/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"shenning/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"shollowa/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"shornema/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"shoxie/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"shrm/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"shume/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sigmataudelta/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sito/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sjenning/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sjharder/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"skalbachteacher/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"slc/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"slynes/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"smarasco/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"smarquez/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"smdebell/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"smichaux/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"smoore3/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"snolte/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"snow/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sociology/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"soe/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"spatters/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"special_ed/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"squalls/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sromani/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ssi/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ssimpson/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ssperry/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sstevens/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sstewart/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sstruess/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sswitzer/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"staffcon/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"stopp/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sttiregion1/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"sttiregion3/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"studentconduct/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"studentsuccess/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"success/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"survey/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"survik/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"svonbret/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"swilhelm/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"swillia4/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"swilson/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"swood/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"swootton/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"szambore/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"taura/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tbarber/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tburkey/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tcarnell/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tcarruth/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tchriste/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tcurtright/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tdubey/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"template/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tenger/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tep/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"test/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tgraves/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"thaberma/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"thanksgiving/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"Theatreworks/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"thuber/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tigger/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tlc/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tlconline/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tleweb/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tlievrouw/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tlind/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tmohl/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tmoore2/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tobster/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tplush/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tprescot/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tprible/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"training5/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"transfer/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"transition/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ttc/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"twynn/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"tzwirlei/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"uaj0sh/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ucaa/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"uccsfilm/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"univcent/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"univcenter/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ur/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"vapa/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"vcaa/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"vcaasearch/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"vcaf/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"vcafsearch/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"visit/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"vlynch/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"vramos/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"vreddy/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"vreed/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"whuddy/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"windows2000/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"wmst/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"women/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"woodfork/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"wrtgcntr/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"xiphi/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"ymeyer/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"youth-u/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else if (strstr(url,"~history/") != NULL){
    return route_to("web.uccs.edu",NON_STICKY,saddr);}
else {
    return route_to("reject",NON_STICKY,saddr);}
}
/* BEGIN r3.txt */
char *mstrstr(char *source,  char *substr, size_t n)
{
  char *p = NULL;
  int  subStrLen = 0;

  p = strstr(source, substr);

  if(p == NULL)
  {
    subStrLen =  strlen(substr);
    if(!memcmp(source + n - subStrLen, substr, subStrLen))
      p = source + n - subStrLen;
  }
  return p;
}


int get_tag_range(char *tag, int pos, char *hay_begin, char *hay_end, char **needle_begin, char **needle_end)
{
  char  temp_buf[67];
  int   curr_pos = 0;
  int   skip_len = 0;
  int   hay_len = 0;
  int   buf_len = 0;
  char  *p = NULL;
  char  *p_tmp = NULL;
  char  *p1 = NULL;
  char  *p_end = NULL;
  char  *p_beg = NULL;
  char  *tag_left = NULL;
  char  *tag_right = NULL;
  
  hay_len = hay_end - hay_begin;
  buf_len = hay_len;
  p = hay_begin;

  while(curr_pos < pos)
  {
    /*
    ** First Remove any leading comments
    */
    sprintf(temp_buf, "%s%s--", c_la, c_ex);


    if((p_tmp = mstrstr(p, temp_buf, hay_len)) != NULL)
    {
      /*
      ** Found the beginning of comment marker "<!--"
      ** Now find the end of comment marker "-->"
      */
       
	sprintf(temp_buf, "--%s", c_ra);


       if((p1 = mstrstr(p_tmp, temp_buf, buf_len - (p_tmp - hay_begin))) != NULL)
       {
         p = p1 + strlen(temp_buf);
         hay_len = buf_len - (p - hay_begin);
         continue;
       }
       else
       {
         (void) fprintf(stderr,"Bad xml data, no ending comment tag\n");
         break;
       }

    }

    sprintf(temp_buf, "%s%s", c_fs, tag);
    /*
    ** First look for end position "/tag" i.e., the vicinity of </tag> 
    */

    if((p_end = mstrstr(p, temp_buf, hay_len)) != NULL)
    {
      curr_pos++;
      if(curr_pos == pos)
      {
        /*
        ** Now look for begin position of the "tag" i.e., the vicinity of <tag>
        */

        if((p_beg = mstrstr(p, tag, hay_len)) != NULL)
        {
          /*
          ** First verify that it is a real tag 
          */

           tag_left = p_beg;
           tag_right = p_beg + strlen(tag);

          /*
          ** i.e, Below is a check for situations like <sometag> AtagB </sometag>
          */

           if(( (memcmp(tag_left - len_sp, c_sp, len_sp)) &&
                (memcmp(tag_left - len_ra, c_la, len_la)) &&
                (memcmp(tag_left - len_cr, c_cr, len_cr)) &&
                (memcmp(tag_left - len_lf, c_lf, len_lf)) ) || 
              ( (memcmp(tag_right, c_sp, len_sp)) &&
                (memcmp(tag_right, c_ra, len_ra)) &&
                (memcmp(tag_right, c_cr, len_cr)) &&
                (memcmp(tag_right, c_lf, len_lf)) ) )
           {
             p = tag_right;
             hay_len = buf_len - (p - hay_begin);
             --curr_pos;
             continue;
           }

           p_beg = tag_right;

           /*
           ** Find the position of '>' for p_beg
           */
           p = mstrstr(p_beg, c_ra, p_end - p_beg);

           if(p == NULL)
           {
             p_beg = NULL;
             p_end = NULL;
             break;
           }

           /*
           ** Find the position of '<' for beginning from p_beg
           */
           p_tmp = mstrstr(p_beg, c_la, p_end - p_beg);

           /*
           ** Below is a check for <sometag> tag </sometag>
           */

           if(p_tmp && (p_tmp < p))
           {
             hay_len = buf_len - (p - hay_begin);
             --curr_pos;
             continue;
           }

          /*
          ** Now eliminate all unwanted characters between p_beg and p_end
          ** such as white space, line feed, carriage return until until
          ** right and left anchors are seen respectively
          */

           if(p != NULL)
             p_beg = p + len_ra;
           else
           {
             /*
             ** We didn't find the  '>' for p_beg
             */
             p_beg = NULL;
             p_end = NULL;
             break;
           }

           /*
           ** Find the position of left anchor for p_end
           */

           while((p_end - max_char_len) > p_beg)
           {
             skip_len = len_la;
             if(!memcmp(p_end - skip_len, c_la, skip_len))
             {
               p_end -= skip_len;
               break;
             }

             skip_len = len_sp;
             if(!memcmp(p_end - skip_len, c_sp, skip_len))
               p_end -= skip_len;


             skip_len = len_cr;
             if(!memcmp(p_end - skip_len, c_cr, skip_len))
               p_end -= skip_len;

             skip_len = len_lf;
             if(!memcmp(p_end - skip_len, c_lf, skip_len))
               p_end -= skip_len;
           }
        }
      }
      else
      {
        /*
        ** Advance p for the next <tag>...data...</tag> block
        */
        p = p_end + strlen(temp_buf);
        hay_len = buf_len - (p - hay_begin);
      }
    }
    else
    /*
    ** No specified needle found in the hay
    */
      break;

  }

  *needle_begin = p_beg;
  *needle_end = p_end;
  
 return 0;

}

/*
** borrwed from thttpd
*/

static int hexDigit(char c)
{
    if (strchr("0123456789abcdefABCDEF",c) != (char *) NULL)
        return (1);

    return (0);
}


int xml_tag_parser(char *buf)
{
  int   buf_len =strlen(buf);
  int   ret = 0;
  int   field_count = 0;
  short done_yet = 0;
  int   skip_len = 0;
  int   pos = 0;
  char  tag[64];
  char  pos_str[10];
  char  *p = NULL;
  char  *p1 = NULL;
  char  *fld_spec_beg = NULL;
  char  *fld_spec_end = NULL;
  char  *data_beg = NULL;
  char  *data_end = NULL;
  char  *tag_beg = NULL;
  char  *tag_end = NULL;


  for(field_count = 0; field_count < num_rule_fields; field_count++)
  { 
    fld_spec_beg = &(rule_fields[field_count].name[0]);
    fld_spec_end = &(rule_fields[field_count].name[strlen(rule_fields[field_count].name)]);
    data_beg = buf;
    data_end =(char *) (buf+buf_len);

    while(fld_spec_beg < fld_spec_end)
    {
      p = (char *)memchr(fld_spec_beg, ':', fld_spec_end - fld_spec_beg);

      if(!p)
      {
        (void) fprintf(stderr,"Invalid rule field specification '%s'\n", rule_fields[field_count].name);
        return -1;
      }

      memcpy(tag, fld_spec_beg, p - fld_spec_beg);
      tag[p - fld_spec_beg] = '\0';

      p += 1;
      p1 = (char *)memchr(p, '.', fld_spec_end - p);


      if(!p1)
      {
        (void) fprintf(stderr,"Invalid rule field specification '%s'\n", rule_fields[field_count].name);
        return -1;
      }

      memcpy(pos_str, p, p1 - p);

      pos_str[p1 - p] = '\0';
      fld_spec_beg = ++p1;

      pos = atoi(pos_str); 
    
      get_tag_range(tag, pos, data_beg, data_end, &tag_beg, &tag_end);
      if((!tag_beg) || (!tag_end))
      {
        (void) fprintf(stderr,"get_tag_range() returned NULL either for tag_beg or tag_end, "
               "tag_beg=%u, "
               "tag_end=%u, "
               "tag=%s, "
               "pos=%d ",
                ((tag_beg) ? (unsigned int) tag_beg : 0),
                ((tag_end) ? (unsigned int) tag_end : 0),
                tag,
                pos);

        return -1;
      }

      if(fld_spec_beg == fld_spec_end)
      {
        /* We have parsed all the sub fields of the field specified in the rule.
        ** Now parse data between tag_beg and tag_end and store in the field value
        ** after skipping white spaces, carriage returns and line feeds.
        */
        done_yet = 0;
        while((tag_beg < tag_end) && !done_yet)
        {
          done_yet = 1;
          skip_len = len_sp;
          if(!memcmp(tag_beg, c_sp, skip_len))
          {
            tag_beg += skip_len;
            done_yet = 0;
          }

          skip_len = len_cr;

          if(!memcmp(tag_beg, c_cr, skip_len))
          {
            tag_beg += skip_len;
            done_yet = 0;
          }

          skip_len = len_lf;
          if(!memcmp(tag_beg, c_lf, skip_len))
          {
            tag_beg += skip_len;
            done_yet = 0;
          }
        }

        done_yet = 0;

        while((tag_beg < tag_end) && !done_yet)
        {
          skip_len = len_sp;
          if(memcmp(tag_end - skip_len, c_sp, skip_len))
            skip_len = 0;

          if(!skip_len)
          {
            skip_len = len_cr;
            if(memcmp(tag_end - skip_len, c_cr, skip_len))
              skip_len = 0;
          }
         
          if(!skip_len)
          {
            skip_len = len_lf;
            if(memcmp(tag_end - skip_len, c_lf, skip_len))
              skip_len = 0;
          }
         
          if(skip_len)
            tag_end -= skip_len;
          else
            done_yet = 1;
        }

        if(tag_beg != tag_end)
        {
          if((tag_end - tag_beg) < sizeof(rule_fields[field_count].value))
          {
            memcpy(rule_fields[field_count].value, tag_beg, tag_end - tag_beg);
            rule_fields[field_count].value[tag_end - tag_beg] = '\0';
          }
          else
            (void) fprintf(stderr,"tag value size=%d is larger than its container size=%d for rule tag '%s' of field spec '%s'\n", (tag_end - tag_beg), sizeof(rule_fields[field_count].value), tag, rule_fields[field_count].name);
        }
        else
          (void) fprintf(stderr,"No value found for rule field spec '%s'\n", rule_fields[field_count].name);
      }
      else
      {
        data_beg = tag_beg;
        data_end = tag_end;
      }
    }
  } 
  return ret;
}



/*
** from thttpd source code
*/
static int hexIt(char c)
{
    if ((c >= '0') && (c <= '9'))
        return (c-'0');

    if ((c >= 'a') && (c <= 'f'))
        return (c-'a'+10);

    if ((c >= 'A') && (c <= 'F'))
        return (c-'A'+10);

    return (0);           /* shouldn't happen, but for saftey  */

}



/*
** from thttpd source code
*/
static char *strDecode(char *from)
{
char *to;
char *start=NULL;

    if (from  == (char *) NULL)
        return ((char *) NULL);


    to = (char *) malloc ((int) strlen(from) + 1);

    if (to == (char *) NULL)
    {
        perror("memory allocation problem strDecode()");
        exit(0);
    }

    start = to;

    for (; *from != '\0'; ++to,++from)
    {
        if (*from == '%' && hexDigit(from[1]) &&
            hexDigit(from[2]))
        {
            *to=hexIt(from[1])*16+hexIt(from[2]);
            from += 2;
        }
        else
            *to = (*from=='+') ?' ': *from;      /* inorder to replace + in post request with a space */
    }
    *to='\0';

return start;
}


u_long ruleMatching(Rule *rule, int *port)
{
  u_long ret_addr = 0;
  int ret=0,i=0;
  
  *port = 80;

  if((ret_addr = findSticky(rule->clientaddr)) > 0)
     return ret_addr;


  if(strncasecmp(rule->method, "POST", 4) == 0)
  {
    if(strstr(rule->content_type,"x-www-form-urlencoded") != NULL)
       (void) fprintf(stderr, " encoded body when decoded =>%d\n",(ret=xml_tag_parser(strDecode(rule->body))));

    for(i=0;i < num_rule_fields;i++)
     (void) fprintf(stderr, "rule %s value %s\n ", rule_fields[i].name, rule_fields[i].value);
  }

  if(ret >= 0)
  {
     ret_addr = (u_long)  rule_configure(rule->url,rule->clientaddr,(u_long) inet_addr(SERVER_IP), (u_short) rule->port, (u_short) SERVER_PORT,12);
     clear_rule_fld_values();
  }

  *port = portno;

  return ret_addr;

}


/* END OF r3.txt */

